
import math
from PrimeGenerator import generate_primes


class DynamicHash:

    def __init__(self):
        self.n=None
        self.m=None
        self.k=None
        self.P=[]
        self.Pfrac=[]
        self.vector=None

    def setup(self, data_set_size, vector_size, number_of_hash):
        self.n=8*int(data_set_size)/8+8
        self.m=8*int(vector_size)/8+8
        self.k=number_of_hash
        self.vector=chr(0)*int(float(self.m)/8)
        self.P=generate_primes(start=4, max=self.m, max_number=self.k+2)[2:]
        print "self.P", self.P

    def encode(self, text, i):
        p_i=self.P[i]
        sum=0
        for j in range(len(text)):
            sum=sum+(math.pow(2,j)*ord(text[j])%p_i )
        return sum

    def seen(self, text):
        pass

    def hasSeen(self, text):
        pass


dh=DynamicHash()
dh.setup(500,100,4)
text="Hej Jag heter Johan det gr jag"
print "encode(text,0)", dh.encode(text,0)
print "encode(text,1)", dh.encode(text,1)
print "encode(text,2)", dh.encode(text,2)
print "encode(text,3)", dh.encode(text,3)
