"""JavaScript object that is stored in a file"""

__version__='$Revision: 1.1 $'[11:-2]

from OFS.content_types import guess_content_type
from Globals import package_home
from App.Common import rfc1123_date
from App.ImageFile import ImageFile
from string import rfind, split
from DateTime import DateTime
from time import time
from os import stat
import os
import Acquisition
import string


class JavaScriptFile(ImageFile):
    """JavaScript objects stored in external files."""

    def __init__(self,path):
        #if _prefix is None: _prefix=SOFTWARE_HOME
        #elif type(_prefix) is not type(''):
        #    _prefix=package_home(_prefix)
        path=os.path.join(package_home(globals()), path)
        self.path=path
        file=open(path, 'rb')
        data=file.read()
        file.close()
        self.content_type='text/javascript'
        self.__name__=path[rfind(path,'/')+1:]
        self.lmt=float(stat(path)[8]) or time()
        self.lmh=rfc1123_date(self.lmt)


   def __len__(self):
        # This is bogus and needed because of the way Python tests truth.
        return 1

    def __str__(self):
        return '<SCRIPT SRC="%s" TYPE="text/javascript"></SCRIPT>' % (self.__name__)

