# $Header: /usr/custom/cvs/public/EnergyPlusLive/lib/python/Products/ZMIPatch/OFS_ObjectManager/__init__.py,v 1.5 2003/12/02 08:44:06 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

__doc__ = """OFS_ObjectManager."""
__version__='$Revision: 1.5 $'[11:-2]

from zLOG import LOG, INFO, BLATHER

from Globals import DTMLFile
from OFS.ObjectManager import ObjectManager
from App.version_txt import getZopeVersion


LOG('ZMIPatch', BLATHER, 'ZMI Patch:OFS.ObjectManager', 'ZMI Patch: OFS ObjectManager: , Enable Labels in the property ManagementView.\n\t\tJohan Carlsson, 2002-10-02, version Easy Publisher 1.8\n')


zope_version=getZopeVersion()
if zope_version[0:3]>=(2,7,0) and zope_version[0:3] < (2,8,0):
    manage_main = DTMLFile('dtml/270/manage_main', globals())
    ObjectManager.manage_main = manage_main
elif zope_version[0:3]>=(2,6,1) and zope_version[0:3] < (2,7,0):
    manage_main = DTMLFile('dtml/261/manage_main', globals())
    ObjectManager.manage_main = manage_main
elif zope_version[0:3]>=(2,5,1)  and zope_version[0:3] < (2,6,1):
    manage_main = DTMLFile('dtml/251/manage_main', globals())
    ObjectManager.manage_main = manage_main
else:
    manage_main = DTMLFile('dtml/261/manage_main', globals())
    ObjectManager.manage_main = manage_main